#!/usr/bin/python
import os
import cgi
import cgitb
cgitb.enable()

showstats = "/opt/maui/bin/showstats %s"

def formatline(line, bg, i, celltype="td"):
    cells = line.split()
    if not cells:
        print "<tr><td>&nbsp;</td></tr>"
        return i
    row = "<%s align='left'> %s </%s>"%(celltype, cells[0], celltype)
    for cell in cells[1:]:
        row += "<%s align='right'> %s </%s>"%(celltype, cell, celltype)
    
    print "<tr bgcolor=%s> %s </tr>" % (bg, row)
    return i+1



showstats_output = os.popen(showstats%"-u",'r').readlines()

def sortkey(l):
    c = l.split()
    if len(c) > 2:
        k = c[2]
        if k.isdigit():
            return -int(k)
    return 0

showstats_output = showstats_output[:4] +\
                        sorted(showstats_output[4:], key=sortkey)

print "Content-Type: text/html"     # HTML is following
print                               # blank line, end of headers
print "<html>"
print "<body BGCOLOR='#FFFFFF'>"
print "<TITLE>showstats</TITLE>"
print "<H1>User stats</H1>"
print "<p><a href='./showq.cgi'>Back to queue</a></p>"
print "<table>"
print """<tr><th></th> <th colspan="3" align="center" bgcolor="green"> Active Jobs</th>
<th colspan="12" align="center" bgcolor="yellow">Completed</th>
</tr>"""

bg = ("'#ffffff'", "'#eeeeee'")
i = 0
ct = "th"
for line in showstats_output[3:]:
    i = formatline(line.strip(), bg[i%2], i, celltype=ct)
    ct = "td"
    
print "</table>"
print "</html>"
print "</body>"
